// Set basic parameters
comicCover.contentFlags = gddContentFlagHaveDetails;
plugin.onAddCustomMenuItems = AddCustomMenuItems;

// activate for backwards and forwards paging, probably for version 1.5
//plugin.plugin_flags = gddPluginFlagToolbarBack + gddPluginFlagToolbarForward;
//plugin.onCommand = ProcessCommands;


var comic = new ContentItem( );
var comics = new Array;
var j = 0;
var h = 158;
var xml_URL = 'http://www.marvel.com/rss/rss.xml?feed=google';

try
{
	PreLoadComics( xml_URL );
	ComicSlideshow();
	startInterval();
} catch(e)
{
	comicCover.removeAllContentItems();
	comic.heading = 'There seems to be a problem with the RSS file.';
	comicCover.addContentItem( comic, gddItemDisplayInSidebar );
}

///////////////////////////////////////////
//////////  MAIN FUNCTIONS ///////////////
///////////////////////////////////////////
function ComicSlideshow() 
{
	comicCover.removeAllContentItems();	
	var comic = new ContentItem();
	var itemLayout = options( "item_layout" );
	
	try
	{
		if( comics[j] == null ) j = 0;
	
		comic.heading = comics[j].title;
		comic.snippet = comics[j].desc;
		comic.open_command = comics[j].link;
		
		//For writing back to the display cell
		if( comic.heading.length > 21 )
  	{
  		comic_text.innerText = comic.heading.substring( 0, 19 ) + '...';
  	} else
  	{
  		comic_text.innerText = comic.heading;
  	}
  	
		
		// This callout is a little bit dumb.  I have to
		// fetch the image as a response.stream since
		// response.text and response.xml aren't functioning
		// correctly.  See API documentation for more details
		fetchImageStream( comics[j].url, comic );
		comic.layout = itemLayout;
		comic.OnDetailsView = viewDetails;
		comic.onProcessDetailsViewFeedback = actionDetails;
		comicCover.addContentItem( comic, gddItemDisplayInSidebar);
		comic = null;

		// When you hit the end, loop back to the beginning.
		( j == comics.length ) ? j = 0 : j++;
		
	} catch(e)
	{
		
	}
}

///////////////////////////////////////////
/////  DETAILS VIEW FUNCTIONS //////////
///////////////////////////////////////////

function viewDetails(comic)
{
	clearInterval( rotation );  // pause the rotation
		
	var control = new DetailsView();
	var tm = new Date();
	control.SetContent( "Marvel Comics", tm.getVarDate(), comic.snippet, true, comic.layout );

  var details = new Object();
  details.details_control = control;
	details.flags = gddDetailsViewFlagToolbarOpen;
 	
 	return details;
}



function actionDetails(comic)
{
	startInterval();
	return false;
}

function ProcessCommands()
{
	gddCmdToolbarBack;
	gddCmdToolbarForward;
}

function startInterval( )
{
	rotation = setInterval( ComicSlideshow, 7000 );
}

function AddCustomMenuItems( Menu ) {
}

///////////////////////////////////////////
/////  IMAGE RETRIEVAL FUNCTIONS //////////
///////////////////////////////////////////


// Pull the comics up from the interwebs.  Formatted as an XML RSS file
// Push the info into the global comics array	
function PreLoadComics( xml_URL ) 
{
	var xmlrequest = false;
	try
	{
		xmlrequest = new XMLHttpRequest();
	} catch(e)
	{
		alert( "Unable to make request to xml file" );
	}
	
	xmlrequest.open( 'GET', xml_URL, true  );
	xmlrequest.onreadystatechange = function() 
	{
		if( xmlrequest.readyState == 4 ) 
		{
			var xmlDoc = new DOMDocument();
			xmlDoc.loadXML(xmlrequest.responseText);
			var xml_comics = xmlDoc.getElementsByTagName("item");
			if( xml_comics != null && xml_comics.length > 0 ) 
			{
				for( var i = 0; i < xml_comics.length; i++ ) 
				{
					comics[i] = new Array;
					for (var node = xml_comics[i].firstChild; node != null; node = node.nextSibling)
					{
						if( node.firstChild != null )
						{
							if( node.nodeName == "title")
							{
								comics[i].title = node.firstChild.nodeValue;
							}
							
							if( node.nodeName == "image" )
							{
								comics[i].url = node.firstChild.nodeValue;
							}
							
							if( node.nodeName == "link" )
							{								
								comics[i].link = node.firstChild.nodeValue;
							}
							
							if( node.nodeName == "description" )
							{
								comics[i].desc = node.firstChild.nodeValue;
							}
						}
					}
				}
			}
		}
	}
	xmlrequest.send(null);
	return true;
}


// Pretty standard AJAX call.  Using ActiveX style so I can get a responseStream
function fetchImageStream(url,contentitem) {
	var stream = false;
	try 
	{
		stream = new ActiveXObject( 'MSXML2.XMLHTTTP' );
	} catch( e ) 
	{
		try 
		{
			stream = new ActiveXObject( 'Microsoft.XMLHTTP' );
		} catch(e) 
		{
			stream = false;
		}
	}
	
	stream.open( 'GET', url, true );
	stream.onreadystatechange = function() 
	{
		if( stream.readyState == 4 ) 
		{
			var response = stream.responseStream;
			contentitem.image = graphics.loadImage( response );
			response = null;
		}
	}
	stream.send(null);
}